/// @description
draw_set_alpha(1);
if (surface_exists(surf)) {
	draw_surface_ext(surf, 0, 0, (min_w / cam_w) * 2, (min_h / cam_h) * 2, 0, c_white, 1);
	surface_set_target(surf);
	draw_clear_alpha(0, 0);
	surface_reset_target();
} else {
	surface = surface_create(max_w, max_h);
}

if (track_clear) {
	track_clear = false;
	surface_set_target(track_surf);
	draw_clear_alpha(0, 0);
	for(var i = 0; i < 1000; i += 10) {
		draw_line(i, 0, i, room_height);
		draw_line(0, i, room_width, i);
	}
	surface_reset_target();
}

draw_set_halign(fa_center);
draw_set_valign(fa_center);
draw_set_font(fnt);
draw_set_color(c_white);
var _num = 0;
with(obj_building) {
	_num += is_burning;
}
if (_num == 1) {
	draw_text(400, 48, "There is 1 burning building!");
} else if (_num > 0) {
	draw_text(400, 48, "There are " + string(_num) + " burning buldings!");
}
draw_text(400, 16, "Cats Saved: " + string(ds_list_size(cats)) + " / 10");

//Button prompt
if (obj_truck.state == PS.shoot) {
	var _pressed;
	var _rotate = 0;
	switch(obj_truck.button_prompt) {
		case vk_right: _rotate = 0; break;
		case vk_left: _rotate = 180; break;
		case vk_up: _rotate = 90; break;
		case vk_down: _rotate = 270; break;
	}
	_rotate += dsin(current_time / 10) * 4;
	if (keyboard_check_pressed(obj_truck.button_prompt) || obj_truck.has_mashed > 3) {
		_pressed = true;
		cam_w_goal = 200;
		cam_h_goal = 150;
	} else {
		_pressed = false;
		cam_w_goal = 400;
		cam_h_goal = 300;
	}
	draw_sprite_ext(spr_buttons, _pressed, 400, 300, 2, 2, _rotate, c_white, 1);
}

//Cats
var _space = 800 / (ds_list_size(cats) + 1);
for(var i = 0; i < ds_list_size(cats); i++) {
	var _cat = cats[| i];
	var _rotate = dsin(current_time / 10) * _cat[1];
	var _up = dsin(current_time / _cat[2]) * 8;
	draw_sprite_ext(spr_cat, 0, ((i + 1) * _space), 632 + _up, 2 * _cat[0], 2, _rotate, _cat[3], 1);
}

//Saving the cats
var _blink = dsin(current_time);
draw_set_color(c_black);
if (obj_truck.state == PS.quicktime) {
	draw_circle_color(400, 300, obj_truck.cat_save_time * 2000, c_white, c_white, false);
	draw_set_circle_precision(48);
	draw_set_alpha(obj_truck.cat_save_time * 0.8);
	draw_circle_color(400, 300, 900 - obj_truck.cat_save_time * 900, c_red, c_red, false);
	draw_circle_color(400, 300, 90, c_white, c_white, false);
	draw_set_circle_precision(24);
	draw_set_alpha(_blink);
	draw_text(400, 300, "PRESS ANY KEY TO SAVE THE CAT!");
	draw_set_alpha(1);
	draw_sprite_ext(spr_cat_fall, 0, 400, 300 * obj_truck.cat_save_time, 2, 2, obj_truck.cat_save_time * 360, c_black, 1);
}
if (obj_truck.state == PS.saved_cat) {
	draw_set_alpha(obj_truck.cat_extra_time < 0.5 ? 1 : 1 - ((obj_truck.cat_extra_time - 0.5) * 2));
	draw_set_color(make_color_hsv(80, 255 * obj_truck.cat_extra_time, 255));
	draw_rectangle(0, 0, 800, 600, false);
	draw_set_color(c_black);
	draw_text(400, 300, "NICE JOB!");
	draw_set_alpha(1);
}
if (obj_truck.state == PS.lost_cat) {
	draw_set_alpha(obj_truck.cat_extra_time < 0.5 ? 1 : 1 - ((obj_truck.cat_extra_time - 0.5) * 2));
	draw_set_color(make_color_hsv(0, 255 * obj_truck.cat_extra_time, 255));
	draw_rectangle(0, 0, 800, 600, false);
	draw_set_color(c_black);
	draw_text(400, 300, "You failed...");
	draw_set_alpha(1);
}
with(obj_confetti) {
	draw_self();
}