/// @description
var _forward = keyboard_check(vk_up) || keyboard_check(ord("W"));
var _rl = sign(keyboard_check(vk_right) + keyboard_check(ord("D")) - keyboard_check(vk_left) - keyboard_check(ord("A")));
var _brake = keyboard_check(vk_down) || keyboard_check(ord("S"));
var _boost = keyboard_check_pressed(vk_space) || keyboard_check_pressed(ord("Z"));
var _jump = keyboard_check_pressed(vk_shift) || keyboard_check_pressed(ord("X"));

if (state == PS.normal) {
	//Interact with buildings
	var _obj = collision_circle(x, y, 32, obj_building, false, true);
	if (_boost && _obj != noone && _obj.is_burning && !jumping) {
		building = _obj;
		state = PS.ladder;
		var _d = point_direction(x, y, _obj.x, _obj.y);
		dir = _d;
		angle = -_d - 90;
		spd = 0;
		instance_create_layer(x, y, layer, obj_ladder);
		obj_game.cam_shake_x = 10;
		obj_game.cam_shake_y = 10;
		cat_save = false;
		cat_save_time = 0;
		with (instance_create_layer(x, y, layer, obj_stabilizers)) {
			image_angle = -other.angle + 90;
		}
		exit;
	}
	
	//Jumping
	if (_jump && (z <= 0 || place_meeting_3D(x, y, z - 1, obj_collision))) {
		zsp = -5;
		jumping = true;
	}
	
	//Boosting
	if (_boost) {
		if (boost_time == 0) {
			drive = 1;
			boost_time = 45;
			instance_create_layer(x, y, layer, obj_siren);
		}
	}
	if (boost_time > 0) {
		with (instance_create_layer(x, y, layer, obj_boost)) {
			image_angle = -other.angle + 90;
		}
		if (!audio_is_playing(epic_drive)) then audio_play_sound(epic_drive, 9, false);
		if (!audio_is_playing(epic_siren)) then audio_play_sound(epic_siren, 10, false);
		_forward = true;
		drive = 1;
		obj_game.cam_w_goal = max_w;
		obj_game.cam_h_goal = max_h;
	} else {
		drive = 0;
		obj_game.cam_w_goal = min_w;
		obj_game.cam_h_goal = min_h;
	}

	//Accelerating
	if (_forward) {
		if (drive == 0) {
			spd += drive_acc;
			spd = min(drive_spd, spd);
		} else {
			spd += boost_acc;
			spd = min(boost_spd, spd);
		}
	} else if (_brake) {
		spd = max(0, spd - brake_fric);
		if (!jumping) {
			with (instance_create_layer(x, y, layer, obj_track)) {
				image_angle = -other.angle + 90;
			}
		}
		if (surface_exists(obj_game.track_surf)) {
			surface_set_target(obj_game.track_surf);
			draw_sprite_ext(spr_tracks, 0, x, y, 1, 1, other.angle, c_white, 1);
			surface_reset_target();
		}
	} else {
		spd = max(0, spd - fric);
	}

	//Turning
	angle += _rl * turn_spd;
	dir = -angle - 90;

	if (spd > 1) {
		obj_game.angle -= angle_difference(obj_game.angle, angle) * 0.2;
	}
} else if (state == PS.ladder) {
	with(obj_ladder) {
		extend++;
		if (extend >= 0) {
			extend = 0;
			other.state = PS.shoot;
		}	
	}
} else if (state == PS.shoot) {
	//Buttons
	button_timer--;
	has_mashed--;
	if (button_timer <= 0) {
		button_timer = 120;
		button_prompt = choose(vk_up, vk_down, vk_right, vk_left);
	}
	var _shots = 0;
	if (keyboard_check_pressed(button_prompt) || has_mashed > 0) {
		obj_game.cam_shake_x = 6;
		obj_game.cam_shake_y = 6;
		_shots = 4;
		if (has_mashed <= 0) {
			has_mashed = 5;
			if (!audio_is_playing(epic_water)) then audio_play_sound(epic_water, 0, false);
		}
	}
	repeat(_shots) {
		with(instance_create_layer(x + lengthdir_x(8, dir), y + lengthdir_y(8, dir), layer, obj_water)) {
			z = other.z + 68;
			zsp = 1;
			spd = random_range(0, 4);
			dir = other.dir + random_range(-6, 6);
		}
	}
	if (!instance_exists(building) || !building.is_burning || _boost) {
		state = PS.no_ladder;
		obj_game.cam_w_goal = 400;
		obj_game.cam_h_goal = 300;
	}
	//Cats
	if (!cat_save && ++cat_timer >= 120) {
		cat_save = true;
		cat_save_time = 0;
		cat_save_cooldown = 0;
		state = PS.quicktime;
		cat_timer = -irandom(60);
	}
} else if (state == PS.no_ladder) {
	with(obj_ladder) {
		extend--;
		if (extend <= -100) {
			other.state = PS.normal;
			instance_destroy();
		}
	}
	with(obj_stabilizers) {
		instance_destroy();
	}
} else if (state == PS.quicktime) {
	cat_save_time += 0.01;
	cat_save_cooldown--;
	var _save = false;
	if (keyboard_check_pressed(vk_anykey) && cat_save_cooldown <= 0) {
		_save = true;
		cat_save_cooldown = 60;
	}
	if (cat_save_time > 0.9) {
		if (_save) {
			state = PS.saved_cat;
			cat_save_time = 0;
			cat_extra_time = 0;
			cat_save_cooldown = 0;
			global.cats_saved++;
			repeat(50) {
				instance_create_layer(400 + irandom_range(-20, 20), 300, layer, obj_confetti);
			}
			//Cats
			ds_list_add(obj_game.cats, [choose(1, -1), random(7), random_range(4, 20), make_color_hsv(irandom(255), 100, 255)]);
		}else if (cat_save_time >= 1) {
			state = PS.lost_cat;
			cat_save_time = 0;
			cat_extra_time = 0;
			cat_save_cooldown = 0;
			global.cats_lost++;
		}	
	}
} else if (state == PS.saved_cat || state == PS.lost_cat) {
	cat_extra_time += 0.005;
	if (cat_extra_time >= 1) {
		state = PS.shoot;
		cat_extra_time = 0;
	}
}

//Z collisions
zsp += 0.3;
if (!place_meeting_3D(x, y, z - zsp, obj_collision)) {
	z -= zsp;
} else {
	zsp = 0;
}
if (z <= 0) {
	z = 0;
	jumping = false;
}

//Collisions
repeat(round(spd)) {
	if (!place_meeting_3D(x + lengthdir_x(1, dir), y + lengthdir_y(1, dir), z, obj_collision)) {
		x += lengthdir_x(1, dir);
		y += lengthdir_y(1, dir);
	} else {
		if (spd >= drive_spd) {
			obj_game.cam_shake_x = 5;
			obj_game.cam_shake_y = 5;
			boost_time = 0;
			global.collisions++;
			audio_play_sound(epic_hit, 1, false);
		}
		spd = 0;
		break;
	}
}

//Boost timer
boost_time = max(0, --boost_time);

//Road boost
if (!jumping) {
	if (place_meeting(x, y, obj_road)) {
		z = 1;
	} else {
		z = 0;
	}
}